Option explicit
'Option autorun on

Const TRUE = 1
Const FALSE = 0
'--- affichage ----
Const TypAff = 0    '0 pas d'affichage, 1=lcd 20x4, 2=tft 2.8", 3= autre a definir
Const gpson = 1   'flag si utilisation gps, 0, no gps, 1= Micromite GPS module, 2= gps in  interrupt mode ,3=gps by i2c

'---- GPS ----
Const cnbcde = 4
Const cnbch = 12

Dim i As integer
Dim i1 As integer
Dim i3 As integer
Dim j1 As integer
Dim j2 As integer
Dim j As integer
Dim txt$ As string
dim vcoul as integer
Dim string txt2$
Dim string txt1$


dim vtmp1 as float  'for timer
'----- tables gps ----
Dim tmcde(cnbcde) As string LENGTH 6   'liste des commandes gps a traiter
Dim tmgps(cnbcde,cnbch) As string LENGTH 20   'texte de chaque case, par type de commande
Dim nbcde As integer    'nombre de cde a traiter
Dim nbgps(cnbcde) As integer   'nombre de champs recu par type de cde
Dim ptcde As integer  'poiteur de la commande en cours
Dim ptgps As integer  'pointeur du N du champs dans la cde en cours
Dim cptgps As integer  'nb car reu
Dim flggps(cnbcde) As integer   'flag des etats de reception de chaque commande (0= rien, 1=en cours, 2=fini)
Dim flgentete As integer   'flag signale qu'on a reu "$" et pas encore ","
Dim tmbuf(10) As string     'pile de recption des trames gps
Dim ptbufecr As integer     'pointeur ecriture des buffers
Dim ptbuflec As integer     'pointeur lecture des buffers
Dim txbufgps$ As string   'buffer de recpetion du gps
Dim txchamp As string   'buffer reception champs en cours
Dim nbcar As integer

Dim icrc As integer     'valeur en cours du crc
Dim txcrc As string     'valeur du crc en hexa
Dim flgcrc As integer   'si =1 alors on calcul le crc, raz apres reception "*"

Dim vtimezoneh As integer    'valeur decalge heures % heure GMT  +/- 12h
Dim vtimezonem As integer    'valeur decalge minutes % heure GMT  x minutes
Dim flghete As integer       'signale si gere heures ete/hiver
Dim vhete As integer        '1 si heure ete, 0 si heure hiver

'...  GPS ...
Dim validgps As integer  'mot d'etat gps (0= tous les defauts), bit 0=crc (1=pas de faut), bit 1= valide (1=valide)
Dim errgps As integer       'compteur d'erreurs
Dim nbsat As integer    'nombre de satellites
Dim tmvsat(12) As integer  'niveau de recpetion des satellites
Dim txlat As string  'vlaeur latitude
Dim txlatns As string   'Nord Sud
Dim txlong As string  'vlaeur longitude
Dim txlongeo As string   'Est Ouest
Dim txspeed As string
Dim txangl As string
Dim txspeedkm As string
Dim txspeedno As string
Dim vvitvoit As integer   'vitesse voiture a afficher
Dim txalti As string
Dim vangle As float
Dim valti As float
Dim vflati As float   'latitude pour gpson=1
Dim vflongi As float   'logitude si gpson=1
Dim vnbsat As integer
Dim vvit As integer
Dim heure$ As string
Dim vheur As integer
Dim minut$ As string
Dim vminu As integer
Dim second$ As string
Dim vsecon As integer
Dim vmilli As integer
Dim vjour As integer
Dim vmois As integer
Dim van As integer
Dim txthgps As string   'gps heure
Dim txtdgps As string   'gps date


vtimezoneh=1  'on est en UTC + 1
flghete=1   'on est en heure d't
vhete=1     'donc +1h
validgps=0

If gpson=2 Then
	For i=1 To cnbcde
	  nbgps(i)=0    'nb rec fields
	  flggps(i)=0   'nb flgas
	  tmbuf(i)=""
	  'tmbufcrc(i)=""
	  For j=1 To cnbch
		tmgps(i,j)=""   'init fields
	  Next j
	Next i

	ptbufecr=0
	ptbuflec=0
	validgps=0
	errgps=0
	ptcde=0
	ptgps=0
	icrc=0
	txcrc=""

	flgentete=0  'flag that receive first "$", (disparait apres rec de ",")
	i=0
	i=i+1:tmcde(i)="$GPGGA"
	'i=i+1:tmcde(i)="$GPGSA"
	i=i+1:tmcde(i)="$GPRMC"
	'i=i+1:tmcde(i)="$GPGSV"
	i=i+1:tmcde(i)="$GPVTG"
	'i=i+1:tmcde(i)="$GPGLL"
	nbcde=i  'nbr command gps to do
	txbufgps$=""
	validgps=0
	Open "COM4:9600,255,spcomrec2" As #5                      ' open the GPS serial interface
	  Pause(1500)  '---wait receive frames
	  If ptbufecr>0 Then validgps=1  
	  'if TypAff=0 then print "valide gps=";str$(validgps)
	  If validgps=1 Then
		if TypAff=2 then Text 400,380,"GPS - OK ",CM,5,1,0 ,RGB(WHITE)
		if TypAff=0 then print "gps ok"
	  Else
		if TypAff=2 then Text 400,380,"GPS - ERREUR ",CM,5,1,RGB(White),RGB(RED)
		if TypAff=0 then print "** gps ERROR **"
	  End If
	  Pause(500)
    	ptbufecr=0
	ptbuflec=0
	validgps=0
	errgps=0
	ptcde=0
	ptgps=0
	icrc=0
	txcrc=""

End If

if gpson=1 then
	if TypAff=2 then Box 100,350,600,60,1,RGB(255,255,255),RGB(255,255,255)
	if TypAff=2 then Text 400,380,"Init GPS",CM,5,1,0 ,RGB(WHITE)
  if TypAff=0 then print "Init GPS"
  on error skip
  close GPS
  OPEN "com4:9600" as GPS,2  'timezone = utc+2
	pause(500)
  'print "time:";GPS(TIME)
	validgps=GPS(VALID)
'----- mettre ici les commandes a anvoyer ua gps avec la fonction "print"
    'exemple:  PRINT #GPS,"$.....*"   'on arrete avec le "*" il calcul le crc

	'if TypAff=0 then print "valide gps=";str$(validgps)
	If validgps=1 Then
		if TypAff=2 then Text 400,380,"GPS - OK ",CM,5,1,0 ,RGB(WHITE)
		if TypAff=0 then print "gps ok"
	Else
		if TypAff=2 then Text 400,380,"GPS - ERREUR ",CM,5,1,RGB(White),RGB(RED)
		if TypAff=0 then print "** gps ERROR **"
	End If
	Pause(500))

end if

if gpson=1 then
  validgps=GPS(VALID)
  'print "valid gps:";validgps
	if validgps=1 then  'si données valides on prend l'heure$
		vjour=val(left$(txthgps,2))
		vmois=val(mid$(txthgps,3,2))
		van=val(right$(txthgps,2))
		 'print len(txthgps);"->";txthgps;"  ";
		txthgps=GPS(TIME)
		vheur=val(left$(txthgps,2))
		vminu=val(mid$(txthgps,3,2))
		vsecon=val(right$(txthgps,2))
		'print txthgps
	end if
end if

SetTick 1000, task1sec,1    ' tache de base a faire toutes les 1 sec

main:
Do
Timer=0  'pour test temps pass --- a retirer avant version finale

  Pause(10)
'---pour test temps pass --- a retirer avant version finale
'print timer/1000
vtmp1=Timer/1000
If vtmp1>0.2 Then
  Print vtmp1
End If
'-----------------
Pause(10)
Loop
Close I2C
if gpson=1 then
CLOSE GPS
end if

'***** FIN BOUCLE Principale ********

Sub lecgps
  txt1$="":txt2$="":txthgps=""
  valti=00:vvit=0:vangle=0:vnbsat=0

if gpson=1 then
	if GPS(VALID)=TRUE then  'si données valides on prend l'heure$
    validgps=GPS(VALID)
		txtdgps=GPS(DATE)
		vjour=val(left$(txtdgps,2))
		vmois=val(mid$(txtdgps,3,2))
		van=val(right$(txtdgps,2))
		 
		txthgps=GPS(TIME)
		vheur=val(left$(txthgps,2))
		vminu=val(mid$(txthgps,3,2))
		vsecon=val(right$(txthgps,2))
		'print txthgps
		'validgps=(validgps or 2)
		validgps=validgps or 2
		vflati=GPS(LATITUDE)
		txt1$=str$(vflati,4,4,"0")+"N"
		vflongi=GPS(LONGITUDE)
		txt2$=right$(str$(vflongi,5,4,"0"),9)+"E"
		valti=GPS(ALTITUDE)
		vangle=GPS(TRACK)
		vvit=GPS(SPEED)
		vnbsat=GPS(SATELLITES)
		if typaff=2 then
			txalti=Str$(valti,4,0," ")  'Right$("    "+Str$(Int(Val(tmgps(i,10)))),4)  '+" "+tmgps(i,11)
			If txalti<>"" Then
				Text 680,22,txalti,RM,4,1,RGB(CYAN),RGB(32,32,32)
			End If
			Text 235,22,Str$(nbsat,2,0,"0"),CM,4,1,RGB(yellow),RGB(32,32,32)
			If txt1$<>"" Then
				Text 360,20,txt1$,CM,2,1,RGB(yellow),RGB(32,32,32)
				Text 530,20,txt2$,CM,2,1,RGB(yellow),RGB(32,32,32)
			End If
			Text 780,22,Str$(vangle,3,0," "),RM,4,1,RGB(yellow),RGB(32,32,32)
		end if
	end if

end if
If gpson=2 Then     'traiement des trames gps locales
  If ptbufecr>0 Then

    For i3=1 To ptbufecr
       txt$=tmbuf(i3)
       'print txt$
       calccrc
       If (validgps And 1) = 1 Then  'if string + crc ok
        rangegps
        'print " Crc Ok"
       Else
         Print " Crc Defaut : ";txcrc;" rec:";txt$
       End If
    Next i3
    ptbufecr=0
  End If
End If

if typaff=0 then
  print "Valid:";str$(validgps)
  print "Time :";"  ";txthgps
  print "Lat  :";txt1$
  print "Lon  :";txt2$
  Print "alt  : ";str$(valti,4,0," ")
  Print "speed: ";str$(vvit,3,0,"0");"   angle:";str$(vangle,3,0,"0")
  print "------------------"
end if

end sub
'------------------------------------
Sub trgps
Local i5 As integer
  i=ptcde
  If flggps(i)=2 Then  'rec valid string
    flggps(i)=3    'wait for reading buffer
    'valti=0
    '--- test valid infos
    If tmgps(i,1)="$GPGGA" Then
        nbsat=Val(tmgps(i,8))  'nbr rec sat
        valti=Val(tmgps(i,10))
        txalti=Str$(valti,4,0," ")  'Right$("    "+Str$(Int(Val(tmgps(i,10)))),4)  '+" "+tmgps(i,11)
        If txalti<>"" Then
            if typaff=2 then Text 680,22,txalti,RM,4,1,RGB(CYAN),RGB(32,32,32)
        End If
        if nbsat<4 then vcoul=rgb(Yellow)
        if nbsat<2 then vcoul=rgb(RED)
        if nbsat=>4 then vcoul=rgb(GREEN)
        if typaff=2 then Text 235,22,Str$(nbsat,2,0,"0"),CM,4,1,vcoul,RGB(32,32,32)
    End If

    If tmgps(i,1)="$GPVTG" Then
       txspeedkm=Right$("   "+Str$(Int(Val(tmgps(i,8)))),3)  'speed in km/h
       'txspeedno=tmgps(i,6)  'speed in miles
        If (txspeedkm<>"") Then
            'Text 500,40,txspeedkm,LM,4,1,RGB(White),RGB(32,32,32)
        End If
     End If
    If tmgps(i,1)="$GPGSA" Then
        posy=44
        taillx=8
     End If

    If tmgps(i,1)="$GPRMC" Then
        If (tmgps(i,3)="A" Or tmgps(i,3)="X") Then validgps=(validgps Or 2) Else validgps=(validgps And &hfd)
        If (tmgps(i,3)="V") Then validgps=(validgps Or 4) Else validgps=(validgps And &hfb)
        'if val(tmgps(i,2))=0 then validgps=(validgps And &hfd)  'si pas d'heure on repasse en non-valid
        'print "va:";(tmgps(i,3)
    '--- rec time---
        vheur=Val(Left$(tmgps(i,2),2))
        vminu=Val(Mid$(tmgps(i,2),3,2))

        vsecon=Val(Mid$(tmgps(i,2),5,2))
        vjour=Val(Left$(tmgps(i,10),2))
        vmois=Val(Mid$(tmgps(i,10),3,2))
        van=Val(Mid$(tmgps(i,10),5,2))
        vminu = vminu + vtimezonem    'on ajoute la time zone
        If vminu=>60 Then
            vheur=vheur+1
            vminu=vminu-60
        End If
        vheur = vheur + vtimezoneh
        If flghete=1 Then vheur = vheur + vhete  'si gestion et/hive et periode ete
        If vheur=>24 Then
          vheur=vheur-24
          vjour=vjour+1
        End If
        heure$=Str$(vheur,2,0,"0")
        minut$=Str$(vminu,2,0,"0")
        second$=Str$(vsecon,2,0,"0")
        txthgps= heure$ + ":" + minut$ + ":" + second$

 
     '---- others infos ---
        txlat =tmgps(i,4)  'vlaeur latitude
        txlatns =tmgps(i,5)  'latitude N/S
        txlong =tmgps(i,6)  'vlaeur longitude
        txlongeo =tmgps(i,7)  'longitude E/Ouest
        'txtll$=Left$(txlat,8)+txlatns+Left$(txlong,8)+txlongeo
        If txlat<>"" Then
            txt1$=Str$(Val(txlat),4,4,"0")+txlatns
            if typaff=2 then Text 360,20,txt1$,CM,2,1,RGB(yellow),RGB(32,32,32)
            txt2$=Str$(Val(txlong),4,4,"0")+txlongeo
            if typaff=2 then Text 530,20,txt2$,CM,2,1,RGB(yellow),RGB(32,32,32)
        End If
        txspeed =tmgps(i,8)  'vitesse
        vvit=Val(txspeed)
        txangl =tmgps(i,9)  'orientation
        vangle=Val(txangl)
        if typaff=2 then Text 780,22,Str$(vangle,3,0," "),RM,4,1,RGB(yellow),RGB(32,32,32)
        'Print vangle,vvit
         If txangl<>"" Then
          'Text 650,40,txangl,LM,4,1,RGB(White),RGB(32,32,32)
         End If


    End If
    'Print "............"


  End If
End Sub


'--- calcul CRC ---
Sub calccrc

    icrc=0
    txcrc=""
    nbcar=0
    j2=Instr(txt,"*")  'end string before crc
    If j2>2 Then
      For i=2 To j2-1
        nbcar=nbcar+1
        icrc=icrc Xor Asc(Mid$(txt,i,1))   'calc crc
      Next i
    End If
    txcrc=Hex$(icrc)
    If Len(txcrc)=1 Then txcrc="0"+txcrc  'put 2 char
    '-- test crc
    If txcrc=Right$(txt,2) Then
        validgps=(validgps Or 1)    'bit error crc
    Else
        validgps=(validgps And &hfe ) 'bit error crc =0
        If errgps <32000 Then errgps=errgps+1    'count error number
    End If

End Sub

'---------
Sub rangegps
Local i1 As integer
Local b2$
Local flgentet1 As integer
  If Left$(txt,1)="$" Then
    ptgps=0
    ptcde=0
    flgentet1=0
    For i1=1 To nbcde
      If Left$(txt,6)=tmcde(i1) Then
        ptcde=i1
        flgentet1=1
        'Print txt
        Exit For
      End If
    Next i1
    If flgentet1=1 Then
      txchamp=""
      For i1=1 To Len(txt)
        b2$=Mid$(txt,i1,1)
        If b2$="," Then
          ptgps=ptgps+1
          If ptgps<=cnbch Then tmgps(ptcde,ptgps)=txchamp
          txchamp=""
        Else
          If Asc(b2$)>31 Then txchamp=txchamp+b2$
        End If
      Next i1
      ptgps=ptgps+1
      If ptgps<=cnbch Then tmgps(ptcde,ptgps)=txchamp
      flggps(ptcde)=2
      nbgps(ptcde)=ptgps
      trgps
    End If
  End If

End Sub


Sub task1sec
    '-- lecture gps -----
  lecgps
End Sub

Sub spcomrec2
Local tx$ As string
Local i2 As integer
Local a$ As string length 1
Local j1 As integer
  nbcar=Loc(#5)
  If nbcar>0 Then
    tx$=Input$(nbcar,#5)
    'Print tx$;
    For i2=1 To nbcar
        a$=Mid$(tx$,i2,1)
        If (a$="$" And flgentete=0) Then
          txbufgps$=""   'init buffer
          flgentete=1     'flg that rec infos
          cptgps=0
        End If
        If flgentete=>1  Then
          If Asc(a$)>31 Then
            If cptgps=5 Then
              For j1=1 To nbcde
                  If txbufgps$+a$=tmcde(j1) Then
                    flgentete=2
                  End If
              Next j1
              If flgentete=1 Then
                flgentete=0
                txbufgps$=""
                cptgps=0
              End If
            End If
            If flgentete=>1 Then
              txbufgps$=txbufgps$+a$
              cptgps=cptgps+1
            End If
          End If
          If (Asc(a$)<=13 And flgentete>1) Then  'end string
            If ptbufecr<10 Then ptbufecr=ptbufecr+1  'ptr buffer
            tmbuf(ptbufecr)=txbufgps$
            txbufgps$=""         'for futur rec
            flgentete=0
            cptgps=0
          End If
        End If
    Next i2
  End If

End Sub
